.\"	$OpenBSD: strlen.3,v 1.11 2013/06/05 03:39:23 tedu Exp $
.\"
.\" Copyright (c) 1990, 1991 The Regents of the University of California.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" Chris Torek and the American National Standards Committee X3,
.\" on Information Processing Systems.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd $Mdocdate: June 5 2013 $
.Dt STRLEN 3
.Os
.Sh NAME
.Nm strlen ,
.Nm strnlen
.Nd find length of a string
.Sh SYNOPSIS
.In string.h
.Ft size_t
.Fn strlen "const char *s"
.Ft size_t
.Fn strnlen "const char *s" "size_t maxlen"
.Sh DESCRIPTION
The
.Fn strlen
function computes the length of the string
.Fa s .
.Pp
The
.Fn strnlen
function computes the length of the string
.Fa s ,
up to
.Fa maxlen
characters.
The
.Fn strnlen
function will never attempt to address more than
.Fa maxlen
characters, making it suitable for use with character arrays that are
not guaranteed to be NUL-terminated.
.Sh RETURN VALUES
The
.Fn strlen
function returns the number of characters that precede the terminating
.Tn NUL
character.
.Pp
The
.Fn strnlen
function returns the number of characters that precede the terminating
.Tn NUL
or
.Fa maxlen ,
whichever is smaller.
.Sh SEE ALSO
.Xr string 3 ,
.Xr wcslen 3
.Sh STANDARDS
The
.Fn strlen
function conforms to
.St -ansiC .
.Pp
The
.Fn strlen
and
.Fn strnlen
functions conform to
.St -p1003.1-2008 .
.Sh HISTORY
The
.Fn strlen
function first appeared in
.At v7 .
The
.Fn strnlen
function appeared in glibc 2.0
and was reimplemented for
.Ox 4.8 .
